package com.zsc.edu.dify.modules.dify.service.Impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.dify.modules.dify.entity.WorkflowData;
import com.zsc.edu.dify.modules.dify.mapper.WorkflowMapper;
import com.zsc.edu.dify.modules.dify.repo.WorkflowRepository;
import com.zsc.edu.dify.modules.dify.service.AppEntityService;
import com.zsc.edu.dify.modules.dify.service.DifyWorkflowService;
import io.github.guoshiqiufeng.dify.workflow.DifyWorkflow;
import io.github.guoshiqiufeng.dify.workflow.dto.request.WorkflowRunRequest;
import io.github.guoshiqiufeng.dify.workflow.dto.response.WorkflowRunResponse;
import jakarta.annotation.Resource;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

@AllArgsConstructor
@Service
public class DifyWorkflowServiceImpl extends ServiceImpl<WorkflowRepository, WorkflowData> implements DifyWorkflowService {
    @Resource
    AppEntityService appEntityService;
    @Resource
    DifyWorkflow difyWorkflow;
    @Resource
    WorkflowMapper mapper;

    /**
     * 运行保存信息
     * @param request
     * @param appId
     * @return
     */
    @Override
    public WorkflowRunResponse run(WorkflowRunRequest request, String appId){
        String apiKey = appEntityService.getApikey(appId);
        request.setApiKey(apiKey);
        WorkflowRunResponse response = difyWorkflow.runWorkflow(request);
        WorkflowData workflowData =mapper.toEntity(response);
        workflowData.setAppId(appId);
        baseMapper.insert(workflowData);
        return response;
    }
}
